unit uzahlfeld;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons;

type
  Tfzahlfeld = class(TForm)
    BitBtn1: TBitBtn;
    Memo1: TMemo;
    baktion: TButton;
    ezahl: TEdit;
    lzahl: TLabel;
    epos: TEdit;
    eergebnis: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    procedure baktionClick(Sender: TObject);
  private
    { Private-Deklarationen}
  public
    { Public-Deklarationen}
  end;

TYPE
  TTyp          = INTEGER;
  FeldTyp       = ARRAY[1..20]OF TTyp;
  FeldlaengeTyp = INTEGER;

VAR
  fzahlfeld: Tfzahlfeld;
  F    : FeldTyp;
  zahl : TTyp;

implementation

{$R *.DFM}

procedure Tfzahlfeld.baktionClick(Sender: TObject);
VAR zahl,position : INTEGER;
    ergebnis      : STRING;

  PROCEDURE Feld_Fuellen;
  {Diese Prozedur fllt das globale Feld F mit Zufallszahlen
  ist fertig programmiert}
  VAR i : INTEGER;
  BEGIN
   FOR i:=1 TO 20 DO F[i]:=RANDOM(6)+1;
  END;

  PROCEDURE Feld_Zeigen;
  {Diese Prozedur soll das Feld auf der Canvas ausgeben
  siehe Formular auf dem Aufgabenblatt}
  VAR i : INTEGER;
  BEGIN
   FOR i:=1 TO 20 DO CANVAS.TEXTOUT(20+20*i,150,INTTOSTR(F[i]));
  END;

  PROCEDURE Feld_Zahl_Zeigen(z:INTEGER);
  {Diese Prozedur soll nur die Feldkomponeten auf der Canvas
  ausgeben, die dem Wert des Parameters z entsprechen}
  VAR i : INTEGER;
  BEGIN
   FOR i:=1 TO 20 DO
    IF F[i]=z THEN CANVAS.TEXTOUT(20+20*i,170,INTTOSTR(F[i]));
  END;

  PROCEDURE Feld_GeradeZahl_Zeigen;
  {Diese Prozedur soll nur die Feldkomponeten auf der Canvas
  ausgeben, die eine gerade Zahl enthalten}
  VAR i : INTEGER;
  BEGIN
   FOR i:=1 TO 20 DO
    IF F[i] MOD 2=0 THEN CANVAS.TEXTOUT(20+20*i,190,INTTOSTR(F[i]));
  END;

  PROCEDURE Feld_Sortieren_Zeigen;
  {Diese Prozedur soll die Feldkomponeten sortieren und
  auf der Canvas ausgeben}
  VAR i,j,z : INTEGER;
  BEGIN
   FOR i:=1 TO 19 DO
     FOR j:=i+1 TO 20 DO
         BEGIN
          IF F[j]<F[i] THEN BEGIN
                             z:=F[j];
                             F[j]:=F[i];
                             F[i]:=z;
                            END;
         END;
   FOR i:=1 TO 20 DO CANVAS.TEXTOUT(20+20*i,210,INTTOSTR(F[i]));
  END;

  PROCEDURE Suche(M:FeldTyp; n:FeldlaengeTyp; k:TTyp; VAR p:INTEGER; VAR txt:STRING);
  {Diese Prozedur soll eine bestimme Feldkomponeten suchen und
  deren Position und Vorhandensein im Feld ausgeben}
  VAR gefunden, i : INTEGER;
  BEGIN
   i:=0; gefunden:=0;
   REPEAT
    INC(i);
    IF M[i]=k THEN BEGIN
                    gefunden:=1;
                    txt:='Vorhanden';
                    p:=i;
                   END
              ELSE BEGIN
                    txt:='NIL';
                    p:=0;
                   END;
   UNTIL (gefunden=1) OR (i=n);
  END;

begin
 REFRESH;
 RANDOMIZE;
 {Editfelder in Variablen einlsen}
 zahl:=STRTOINT(ezahl.Text);

 {Prozeduren aufrufen}
 Feld_Fuellen;
 Feld_Zeigen;
 Feld_Zahl_Zeigen(zahl);
 Feld_GeradeZahl_Zeigen;
 Suche(F,20,zahl,Position,Ergebnis);
 Feld_Sortieren_Zeigen;


 {Editfelddaten des Suchvorganges ausgeben}
 eergebnis.Text:=ergebnis;
 epos.Text:=INTTOSTR(Position);
end;

end.
